#include <stdio.h>
#include <stdlib.h>
#include <math.h>                          // each model has 2 err, err2 ignore
#define  nn    99999                       // UBAND SLONG data
double aa[nn],dd[nn];                      
short  griz[nn][5];                       // ugriz_psf
double rc,dc,a_c,d_c,up_a,dn_a,up_d,dn_d,ddc;
double hs,cx,cy,hs2,pi,cosdc;
int    u3index[471][360],n;       
FILE   *fp;
char   dir[50];
float  w_de,xlim;
short  maglim;

main(int ac,char **av)
{
  double hw_de,hw_al,xa,xd,z;
  char   ch,cc,sg,c1[14],c2[14],dis[99];
  int    i,j,k,k1,k2,m;
  char   t[80];
  char   c39=39;
  if(ac<5){ printf("\n\t**** INDEX dr10_psf in color *****");
            printf("             jiang 201412\n");
    printf("\n\t\tUsage: dr10psf ra dec field maglimit color\n");
    printf("\n\t\tEx: dr10psf 21:13:47.590 01:52:38.13 31 23 g\n");
    printf("\n\t\t\t   u  g  r  i  z");
    printf("\n\t\t\t0  1  2  3  4  5\n");
    printf("\n\t\t 0  means display all 5 color");
    printf("\n\t\t    epoch == 2000.0");
    printf("\n\t\t    field in arcmin");
    printf("\n\t\t    color; ra,dec also canbe in digital\n\n");    
    exit(0);
  } 
  pi=4.*atan(1.); cx=pi/12.; cy=pi/180.;
  strcpy(dir,getenv("DR10_PSF"));
  sprintf(t,"%s/dr10.unf",dir);
  fp=fopen(t,"rb");
  if(!fp){ printf("\n\t DR10_data should put to %s\n",dir); exit(0); }
  fread(u3index,360*441,4,fp); fclose(fp);
  strcpy(dis,av[1]); strcat(dis," "); strcat(dis,av[2]);
  j=0; for(i=0;i<strlen(dis);i++)if(dis[i]==':')j=1;
  if(j==0){ sscanf(dis,"%lf",&rc); sscanf(av[2],"%lf",&dc); }
  else itohd(dis,&rc,&dc,&z);
  while(rc>24.)rc-=24.;     while(rc<0.)rc+=24.;
  ddc=dc; if(dc>85.)dc=85.;  if(dc<-25.25)dc=-25.25;
  sscanf(av[3],"%f",&w_de);
  if(w_de<2.)w_de=2.; if(w_de>60.)w_de=60.;
  hw_de=w_de/120.;
  up_d=dc+hw_de;    dn_d=dc-hw_de; 
  xa=cos(up_d*cy);  xd=cos(dn_d*cy);  z=xa; if(z>xd)z=xd;
  hw_al=hw_de/z/15.;  if(hw_al>12.)hw_al=12.;
  up_a=rc+hw_al;      if(up_a>=24.)up_a-=24.;
  dn_a=rc-hw_al;      if(dn_a<  0.)dn_a+=24.;
  hs=hw_de*cy;   hs2=255./hs;
  a_c=rc*cx;     d_c=dc*cy;
  cosdc=cos(d_c); if(cosdc<.05)cosdc=.05;
  n=0;
  k1=(dn_d+25.25)*4.;  k2=(up_d+25.25)*4.+0.9999;
  if(k1<0)k1=0; if(k2>440)k2=440;
  sscanf(av[4],"%f",&xlim);         // mag limit
  if(xlim>26.)xlim=26.;
  maglim=xlim*1000.; 
  cc=av[5][0]; ch=cc;
  if(cc=='u')ch='1';  
  if(cc=='g')ch='2';
  if(cc=='r')ch='3';
  if(cc=='i')ch='4';
  if(cc=='z')ch='5';
  ch-=48;
  if(ch<1 || ch>5)ch=0;  j=ch;
//printf("%d\n",ch);
  if(ch==1)cc='u';
  if(ch==2)cc='g';
  if(ch==3)cc='r';
  if(ch==4)cc='i';
  if(ch==5)cc='g';
  for(i=k1;i<k2;i++)cat_dr10psf(i,j);      // n+++
  toms2(rc,c1,1); toms2(ddc,c2,0);
  if(j){ printf("#center:%s %s (2000.0)%6.1f%c%6.1fm  %c  %d\n",
    c1,c2,w_de,c39,xlim,cc,n);
    printf("#----------------------------------- %c ---\n",cc);
  } else { printf("#center:%s %s (2000.0)%6.1f%c%6.1fm  ugriz  %d\n",
    c1,c2,w_de,c39,xlim,n);
    printf("#-------------- -------------------- u ---- g ---- r ---- i ---- z --\n");
  }
  sortd4(aa,dd,griz,n);
  for(i=0;i<n;i++){
    sg='g'; if(aa[i]<0.){ aa[i]=-aa[i]; sg='s'; }
    toms2(aa[i],c1,1); toms2(dd[i],c2,0); 
    if(j)printf("%5d:%s %s %c %6.3f\n",i+1,c1,c2,sg,griz[i][j-1]*0.001);
    else {
         printf("%5d:%s %s %c%7.3f%7.3f%7.3f%7.3f%7.3f\n",
         i+1,c1,c2,sg,    griz[i][0]*0.001,griz[i][1]*0.001,
         griz[i][2]*0.001,griz[i][3]*0.001,griz[i][4]*0.001);
    }
  }
}

i_star(ra,dc,ix,iy)
double ra,dc; short *ix,*iy;
{
  double xa,xd,xi,xn;
  xa=ra*cx; xd=dc*cy;
  standc(a_c,d_c,xa,xd,&xi,&xn);
  *ix=hs2*(hs-xi)+.5;
  *iy=hs2*(xn-hs)+510.5;
  if(*ix < 0 || *ix >510)return(0);
  if(*iy < 0 || *iy >510)return(0);
  return(1);
}

struct { double ra,dc; short ugriz[5]; } u;
cat_dr10psf(int i360,int ch)
{
  double x1,x2, ra,dc,xa,xd;
  short  ix,iy;
  char   f1[30];
  int    i,j,k;
  i=i360;
  x1=dn_a; x2=up_a;  if(x2<x1)x2+=24.;
  j=x1*15.; j--; if(j<0)k=0; else  k=u3index[i][j];
  if(i360<101)sprintf(f1,"%s/S%02d%c\0",dir,(100-i)/4,((100-i)%4)+97);
  else        sprintf(f1,"%s/N%02d%c\0",dir,(i-101)/4,((i-101)%4)+97);
  fp=fopen(f1,"rb"); if(!fp)return;
l05:
  fseek(fp,k*26,0);
l10:
  fread(&u,1,26,fp);   if(feof(fp))goto l20;
  k++;
  ra=u.ra/15.; if(ra<0.)ra=-ra;     // -ra means type=star
  if(ra>x2)goto l100;               // normal exit
  if(ra<x1)goto l10;
  dc=u.dc;    if(dc<dn_d || dc>up_d)goto l10;
  if(ch){
    if(u.ugriz[ch-1]>maglim)goto l10;
  } else {
    j=1;
    for(i=0;i<5;i++)if(u.ugriz[i]<maglim)j=0;
    if(j)goto l10;
  }
  if(i_star(ra,dc,&ix,&iy)){
    aa[n]=u.ra/15.;
    dd[n]=dc;
    for(i=0;i<5;i++)griz[n][i]=u.ugriz[i];
    n++; if(n==nn)n--;
  }
  goto l10;
l20:
  x1-=24.; x2-=24.;  k=0;
  goto l05;
l100:
  fclose(fp);
}

toms2(aa,c,k)
double aa;           // input
char c[14];          // output
int k;               // input
{
  int  i,j;
  double a,b,x;
  a=aa;
  if(k==1){ if(a>24.)a-=24.; if(a<0.)a+=24.; }
  c[0]=32; if(a<0.){ a=-a; c[0]='-'; }
  i=a; b=(a-i)*60.;
  j=b; x=(b-j)*60.;
  if(j==60){ j=0; i++; }
  if(k==1)sprintf(&c[1],"%2.2d:%2.2d:%6.3f",i,j,x);
  if(k==0)sprintf(&c[1],"%2.2d:%2.2d:%5.2f",i,j,x);
  if(c[7]==32)c[7]='0';   if(c[8]==32)c[8]='0';
  if(c[7]=='6'){
    c[7]='0'; j++; sprintf(&c[4],"%2.2d",j);
    if(c[4]=='6'){
      c[4]='0'; i++; sprintf(&c[1],"%2.2d",i);
    }
    c[3]=':'; c[6]=':';
  }
}

standc(rc,dc,ra,de,xi,xn)
double rc,dc,ra,de,*xi,*xn;
{
  double sd,cd,td,co,tmp;
  sd=sin(dc);
  cd=cos(dc);
  td=tan(de);
  co=cos(ra-rc);
  tmp=sd*td+cd*co;
  *xi=sin(ra-rc)/tmp;
  *xn=(cd*td-sd*co)/tmp;
}

itohd(a,rc,dc,epoch)
char *a; double *rc,*dc,*epoch;
{
  int i,j,k;
  int i1,i2,g1,g2,g3,p;
  double x3;
  char b[70];
  strcpy(b,a);
  i1=i2=g1=g2=g3=p=0;
  *rc=*dc=*epoch=0.;
  k=strlen(a);
  for(i=0;i<k;i++)if(b[i]<=',')b[i]=32; //allowed comma and below
  for(i=0;i<k;i++)if(b[i]!=32)break;
  if(i!=k)g1=i; else goto l10;
  for(j=g1;j<k;j++)if(b[j]==32)break;
  for(i=j;i<k;i++)if(b[i]!=32)break;
  if(i!=k)g2=i; else goto l10;
  for(j=g2;j<k;j++)if(b[j]==32)break;
  for(i=j;i<k;i++)if(b[i]!=32)break;
  if(i!=k)g3=i;
l10:
  for(i=0;i<k;i++){ if(b[i]==':')b[i]=32; if(b[i]=='-')p=1; }
  if(g2)b[g2-1]=0;
  sscanf(b,"%d %d %lf",&i1,&i2,&x3);
  *rc=i1+i2/60.+x3/3600.;
  if(g2==0)goto l20;
  if(g3)b[g3-1]=0;
  i2=0; x3=0.; sscanf(&b[g2],"%d %d %lf",&i1,&i2,&x3);
  if(i1<0)i1=-i1;
  *dc=i1+i2/60.+x3/3600.;
  if(p)*dc=-*dc;
  if(g3)sscanf(&b[g3],"%lf",epoch);
l20: ;
}

sortd4(x,y,griz,n)
int n; double *x,*y; short griz[nn][5];
{
  int i,j,k=2,l,ii,ifin; double xx,yy; short  g16[5];
  while(k<n)k*=2;
  k=(3*k)/4-1; if(n<k)k=n;
l20:
  k/=2;        ifin=n-k;
  for(ii=0;ii<ifin;ii++){
    i=ii;      j=i+k;
    if(y[i]<=y[j])continue;
    xx = x[j];      yy= y[j]; 
    for(l=0;l<5;l++)g16[l]=griz[j][l];
l40:
     x[j]= x[i];  y[j]= y[i];
    for(l=0;l<5;l++)griz[j][l]=griz[i][l];
    j=i;       i-=k;
    if(i<0)goto l60;
    if(y[i]>yy)goto l40;
l60:
     x[j]=xx;       y[j]=yy;
    for(l=0;l<5;l++)griz[j][l]=g16[l];
  }
  if(k>1)goto l20;
}
